package IM;

import java.lang.*;
import java.io.*;
import java.net.*;

class Receive {
    public static void main(String args[]) {
	try {
	    String CAaddress = "localhost";
	    int port;
	    int CAport;

	    FileReader fr = new FileReader("config");
	    BufferedReader in = new BufferedReader(fr);
	    in.readLine();
	    port = Integer.parseInt(in.readLine());
	    CAport = Integer.parseInt(in.readLine());
	    in.close();
	    fr.close();

	    if (args.length < 1) {
		System.out.println("Usage: receive <username>");
		return;
	    }

	    if (args.length > 1) {
		port = Integer.parseInt(args[1]);
	    }
	    if (args.length > 2) {
		CAport = Integer.parseInt(args[2]);
	    }

	    String username = args[0];

	    //The user's private key file is: username + ".priv"

	    String badwords[] = load_badwords();
	    ServerSocket srvr = new ServerSocket(port);

	    for (;;) {
		Socket skt = srvr.accept();
		System.out.print("[incoming message...]\n");

		ObjectInputStream objin = new ObjectInputStream(skt.getInputStream());

		Message msg = (Message) objin.readObject();
		objin.close();
		skt.close();

		//TODO:
		//1. Read receiver's private key (e.g. "bob.priv")
		//2. Read sender's public key (e.g. "alice.pub")
		//3. Verify signature on revocation list
		//   before testing if sender is on list.
		//4. Decrypt and verify message.
		//   (This should be impossible if the message is intended
		//   for someone else.)
		//5. If message is banned then pass it on to the CA.
		//   Also include sender's signature as evidence
		//6. Otherwise print the timestamp, sender and message

		FileInputStream fis = new FileInputStream("revocationlist");
		ObjectInputStream ois = new ObjectInputStream(fis);
		String rl[] = (String[]) ois.readObject();
		ois.close();
		fis.close();
		int i;

		boolean is_revoked = false;

		for (i=0; i<rl.length; i++) {
		    if (rl[i].equals(msg.sender)) {
			is_revoked = true;
			break;
		    }
		}

		if (is_revoked) {
		    System.out.print("[Sender is revoked, ignoring message]\n");
		} else if (is_banned(msg.message, badwords)) {
		    System.out.print("[Banned message received. Notifying authorities...]\n");

		    Socket CAskt = new Socket(CAaddress, CAport);
		    ObjectOutputStream objout = new ObjectOutputStream(CAskt.getOutputStream());

		    Squeal squeal = new Squeal();
		    squeal.set(msg.sender, msg.message);
		    objout.writeObject(squeal);
		    objout.close();
		    CAskt.close();

		} else {
		    System.out.print(msg.sender);
		    System.out.print(": ");
		    System.out.println(msg.message);
		}
	    }

	//Note: ideally there should be a more graceful way to stop the server
	//and then we'd call srvr.close();

	}
	catch(Exception e) {
	    System.out.print("Error\n");
	}
    }

    private static String[] load_badwords() {
	try {
	    FileInputStream fis = new FileInputStream("banned");
	    ObjectInputStream ois = new ObjectInputStream(fis);
	    String badwords[] = (String[]) ois.readObject();
	    ois.close();
	    fis.close();
	    return badwords;
	}
	catch(Exception e) {
	    System.out.print("Can't read banned words\n");
	    String empty[] = new String[0];
	    return empty;
	}
    }

    private static boolean is_banned(String message, String badwords[]) {
	int i;
	int n = badwords.length;
	int index;
	for (i=0; i<n; i++) {
	    index = message.indexOf(badwords[i]);
	    if (index >= 0) return true;
	}
	return false;
    }
}
